# FileIO.py
# Name: Alex Cappiello
# AndrewID: acappiel
# Section: H
# Term project for 15-110, spring 2011
# All code original work unless otherwise noted

import tkMessageBox, tkFileDialog, DrawingTools, Dialogs
from PIL import Image, ImageTk
#from Tkinter import Toplevel

def new():
    dialog = Dialogs.Resize( root, canvas.data.size[ 0 ], canvas.data.size[ 1 ],
                             title = "Dimensions for new canvas" )
    if ( dialog.success ):
        offset = canvas.data.drawOffset
        canvas.configure( width = dialog.width, heigh = dialog.height,
                          scrollregion = ( offset, offset, dialog.width,
                                           dialog.height ) )
        DrawingTools.blankImage( dialog.width, dialog.height )
        canvas.data.redraw = True
        canvas.data.unsavedChanges = False
        #Making a new image breaks pointers. Reset!
        DrawingTools.configure()

def load():
    txt = "All Supported"
    allExt = [(txt,".png"),(txt,".jpg"),(txt,".jpeg"),(txt,".bmp"),
              (txt,".gif"),(txt,".ico"),(txt,".pbm"),(txt,".pgm"),
              (txt,".ppm"),(txt,".psd"),(txt,".tiff")]
    readTypes=allExt+[("PNG",".png"),("JPEG",".jpg"),("JPEG",".jpeg"),
                      ("Bitmap",".bmp"),("GIF",".gif"),
                      ("Icon (read only)",".ico"),("PPM",".pgm"),
                      ("PPM",".pgm"),("PPM",".ppm"),
                      ("PSD (read only)",".psd")]
    path = tkFileDialog.askopenfilename( filetypes = readTypes )
    if ( not path == "" ):
        offset = canvas.data.drawOffset
        rawImage = Image.open( path )
        size = rawImage.size
        canvas.configure( width = size[ 0 ], heigh = size[ 1 ],
                          scrollregion = ( offset, offset, size[ 0 ],
                                           size[ 1 ] ) )
        canvas.data.path = path
        canvas.data.rawImage = rawImage
        canvas.data.size = size
        canvas.data.redraw = True
        canvas.data.unsavedChanges = False
        #Loading the image breaks pointers. Reset!
        DrawingTools.configure()

def save():
    if ( not canvas.data.path == "" ):
        canvas.data.rawImage.save( canvas.data.path )
        canvas.data.unsavedChanges = False
    else:
        saveAs()

def saveAs():
    saveTypes=[("PNG",".png"),("JPEG",".jpg"),("JPEG",".jpeg"),
               ("Bitmap",".bmp"),("GIF",".gif"),("PDF (save only)",".pdf"),
               ("PPM",".pgm"),("PPM",".pgm"),("PPM","*ppm")]
    path = tkFileDialog.asksaveasfilename()#filetypes=saveTypes)
    if ( not path == "" ):
        try:
            canvas.data.rawImage.save( path )
            canvas.data.path = path
            canvas.data.unsavedChanges = False
        except KeyError:
            body = "File extension error. Must be entered manually."
            tkMessageBox.showerror( "Invalid", body )
    
def about():
    body = """
Version 0.2 alpha\n
Created by Alex Cappiello\n
(c)2011\n
Icons used under proper licencing:
(c)Fatcow Web Hosting: http://www.fatcow.com/
(c)Fast Icon: http://fasticon.com
"""
    tkMessageBox.showinfo( "About", body )
